use std::path::Path;

use crate::state::Layers;

extern crate ocl;
pub mod layer;
pub mod state;

static SAVE: &str = "save.bin";

#[derive(Debug, thiserror::Error)]
pub enum Error {
    #[error("`{0}`")]
    OpenCL(#[from] ocl::Error),
    #[error("`{0}`")]
    Bincode(#[from] Box<bincode::ErrorKind>),
    #[error("`{0}`")]
    IO(#[from] std::io::Error),
}

#[monoio::main]
async fn main() {
    let layers = match Path::new(SAVE).exists() {
        true => Layers::new(),
        false => Layers::load_from(SAVE).await.unwrap(),
    };
    todo!()
}
